VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "HID Terminal"
   ClientHeight    =   2280
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3030
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2280
   ScaleWidth      =   3030
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton Command1 
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Top             =   1800
      Width           =   2535
   End
   Begin VB.Frame Frame1 
      Caption         =   "Product Information"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   2775
      Begin VB.Label ID 
         Caption         =   "ID:"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   1935
      End
   End
   Begin VB.Frame Frame8 
      Caption         =   "Terminal"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   2775
      Begin VB.TextBox CommandText 
         BackColor       =   &H00FFFFFF&
         Height          =   285
         Left            =   960
         TabIndex        =   3
         Top             =   240
         Width           =   1725
      End
      Begin VB.TextBox ReplyText 
         BackColor       =   &H8000000B&
         Height          =   285
         Left            =   960
         TabIndex        =   2
         Top             =   600
         Width           =   1725
      End
      Begin VB.Label Label24 
         Caption         =   "Command:"
         Height          =   195
         Left            =   120
         TabIndex        =   5
         Top             =   280
         Width           =   735
      End
      Begin VB.Label Label28 
         Caption         =   "Reply:"
         Height          =   195
         Left            =   120
         TabIndex        =   4
         Top             =   640
         Width           =   735
      End
   End
   Begin VB.TextBox checkReply 
      Height          =   285
      Left            =   10440
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   720
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
' Declarations of the ARCUS HID DLL APIs
Private Declare Function GetArcusHIDnumber Lib "HidApiDll" () As Long

Private Declare Function GetArcusHIDName Lib "HidApiDll" _
(ByVal HidIndex As Long, ByVal HidName As String) As Long

Private Declare Function OpenArcusHID Lib "HidApiDll" _
(ByRef HidHandle As Long, ByVal HidName As String) As Long

Private Declare Function CloseArcusHID Lib "HidApiDll" _
(ByVal HidHandle As Long) As Long

Private Declare Function SendReceiveArcusHID Lib "HidApiDll" _
(ByVal HidHandle As Long, ByVal command As String, ByVal reply As String) As Long

' Global Handle to the ARCUS HID
Public HidHandle As Long
Public ComStatus As Boolean
Dim pausePolling As Boolean
Dim minPolling As Boolean
Dim performMove As Boolean

Private Sub Command1_Click()
    Dim retVal As Long
    
    retVal = CloseArcusHID(HidHandle)
    Unload Me
End Sub

Private Sub CommandText_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim command As String * 63
    Dim reply As String * 63
    Dim retVal As Integer
    Dim lastTimer1 As Double
    Dim lasttimer2 As Double
    Dim deltaTimer As Double
    
    On Error GoTo ComFail
    
    lastTimer1 = Timer
    For i = 0 To i = 100
        lvalue = lvalue + 1
    Next i
    
    If (KeyCode = 13) Then
        command = CommandText
        'lastTimer1 = Timer
        retVal = SendReceiveArcusHID(HidHandle, command, reply)
        'lasttimer2 = Timer
        'deltaTimer = lasttimer2 - lastTimer1
        ReplyText = reply
        CommandText = ""
    End If
    
    Exit Sub
ComFail:

End Sub

Private Sub Form_Load()
    Dim numberHIDs As Long
    Dim HidIndex As Long
    Dim HidName As String * 12
    Dim command As String * 63
    Dim reply As String * 63
    Dim deviceStr As String
    Dim selectedDevice As Long
    Dim retVal As Long
    Dim lvalue As Long
    Dim i As Integer
    
    On Error GoTo ComFail
    
    ' Get the number of connected ARCUS-HIDs
    numberHIDs = GetArcusHIDnumber()
    
    If numberHIDs > 0 Then
        retVal = GetArcusHIDName(HidIndex, HidName)
        retVal = OpenArcusHID(HidHandle, HidName)
    Else
        MsgBox ("No Performax Device Connected!")
        ComStatus = False
        GoTo ComFail
    End If

    ID = ID + HidName
    
ComFail:

End Sub

Public Function BitAND(tv1 As Long, tv2 As Long) As Long

Dim result, temp1, temp2, V1, V2 As Long
Dim i As Integer

result = 0
V1 = tv1
V2 = tv2
For i = 23 To 0 Step -1 '*** 32 bit numbers
    temp1 = V1 \ (2 ^ i) 'gets the bit of text1.text
    V1 = V1 - temp1 * (2 ^ i) 'subtracts it from the number
    temp2 = V2 \ (2 ^ i) 'gets the bit of text2.text
    V2 = V2 - temp2 * (2 ^ i) 'subtracts it from the number
    If temp1 = 1 And temp2 = 1 Then 'If both are equal to 1 then return a 1
        result = result + (2 ^ i) 'This returns a decimal number
    End If
Next i

BitAND = result

End Function

Public Function BitOR(tv1 As Long, tv2 As Long) As Long

Dim result, temp1, temp2, V1, V2 As Long
Dim i As Integer

result = 0
V1 = tv1
V2 = tv2
For i = 23 To 0 Step -1 '24 bit numbers accepted
    temp1 = V1 \ (2 ^ i) 'gets the bit of text1.text
    V1 = V1 - temp1 * (2 ^ i) 'subtracts it from the number
    temp2 = V2 \ (2 ^ i) 'gets the bit of text2.text
    V2 = V2 - temp2 * (2 ^ i) 'subtracts it from the number
    If temp1 = 1 Or temp2 = 1 Then ' If one or the other or both=1 then return a 1
        result = result + (2 ^ i) 'This returns a decimal number
    End If
Next i

BitOR = result

End Function

Public Function BitShiftLeft(V1 As Long, V2 As Long) As Long

Dim result As Long

result = V1 * 2 ^ V2 ' This shifts the bits

BitShiftLeft = result

End Function

Public Function BitShiftRight(V1 As Long, V2 As Long) As Long
Dim result As Long

result = V1 \ 2 ^ V2 ' This shifts the bits

BitShiftRight = result

End Function
